unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, PairSplitter,
  ExtCtrls, ComCtrls, StdCtrls, Spin, Menus, Graph2D, functions, settings, Math, INIFiles;

type

  TRelPos = record
   t, l : integer;
   a  : byte;
   el : TControl;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    ButtonExport: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBoxAutoDel: TCheckBox;
    CheckBoxTransform: TCheckBox;
    CheckBoxAutoView: TCheckBox;
    EditExportName: TEdit;
    EditExportPath: TEdit;
    EditLs2U: TEdit;
    EditIoutU: TEdit;
    EditVoutU: TEdit;
    EditR2U: TEdit;
    EditU: TEdit;
    EditErr: TEdit;
    EditSteps: TEdit;
    EditCq1: TEdit;
    EditCq2: TEdit;
    EditCres: TEdit;
    EditIout: TEdit;
    EditLh: TEdit;
    EditLs1: TEdit;
    EditLs2: TEdit;
    EditR2: TEdit;
    EditSteps1: TEdit;
    EditToff: TEdit;
    EditTon: TEdit;
    EditVin: TEdit;
    EditVout: TEdit;
    Circuit: TImage;
    Image2: TImage;
    Image3: TImage;
    CircuitU: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    LabelF: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label9: TLabel;
    LabelIout: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LabelVout: TLabel;
    LabelAlert: TLabel;
    MainMenu1: TMainMenu;
    MemoLog: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    SaveDialog1: TSaveDialog;
    SpinEditExportResolution: TSpinEdit;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Timer1: TTimer;
    TimerExport: TTimer;
    TrackBar1: TTrackBar;
    procedure DoExport(Sender: TObject);
    procedure ExportFinish(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxChange(Sender: TObject);
    procedure FrameResize(Sender: TObject);
    procedure LogEnableDisable(Sender: TObject);
    procedure OpenFile(Sender: TObject);
    procedure ParamChange(Sender: TObject);
    procedure SaveFile(Sender: TObject);
    procedure SaveFileAs(Sender: TObject);
    procedure SetValues(Sender: TObject);
    procedure ShowChange(Sender: TObject);
    procedure ShowLog(Sender: TObject);
    procedure TransformChange(Sender: TObject);
  private
   relativePositions : Array of TRelPos;
   startH, startW : integer;
   Iout : Precision;
   steps : integer;
   Graph : TGraph2D;
   switchOnVoltage, switchOnCurrent, switchOffCurrent, voltageStability : TGraph2D.TLine;
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  settingsFile : String = '';

implementation

var err : Boolean = false;
function ValToFloat(Val : String = ''; El : TEdit = nil) : Precision;
var
 i : integer;
 e : precision;
 v : WideString;
begin
 if (Val = '') then v := El.Text else v := Val;
 e := 1;
 if (Length(v) > 0) then for i := 0 to Length(TGraph2D.physUnitSymbols)-1 do if (TGraph2D.physUnitSymbols[i] = v[Length(v)]) then begin
  e := TGraph2D.physUnitValues[i];
  SetLength(v, Length(v)-1);
  break;
 end;
 try
  Result := StrToFloat(v) * e;
  if (El <> nil) and (El.Color = $006060FF) then El.Color := $00FFFFFF;
 except
  Result := Poly.NaN;
  err := true;
  if (El <> nil) then El.Color := $006060FF;
 end;
end;

function ValToInt(El : TEdit) : integer;
var
 i : integer;
 v : String;
begin
 v := El.Text;
 try
  Result := StrToInt(v);
  El.Color := $00FFFFFF;
 except
  Result := 0;
  err := true;
  El.Color := $006060FF;
 end;
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var ax : TGraph2D.TAxis;
  procedure addRel (el : TControl; a : byte);
  var n : integer;
  begin
   n := Length(relativePositions);
   SetLength(relativePositions, n+1);
   relativePositions[n].el := el;
   relativePositions[n].l := el.Left;
   relativePositions[n].t := el.Top;
   relativePositions[n].a := a
  end;
begin
 // Graph
 Graph := TGraph2D.Create(self);
 settings.Graph := Graph;
 Graph.Parent := PairSplitterSide1;
 Graph.AnchorParallel(akTop, 0, PairSplitterSide1);
 Graph.AnchorParallel(akLeft, 0, PairSplitterSide1);
 Graph.AnchorParallel(akRight, 0, PairSplitterSide1);
 Graph.AnchorParallel(akBottom, 0, PairSplitterSide1);
 Graph.XAxis[0].Min := 0;
 Graph.XAxis[0].Max := 10E-6;

 ax := TGraph2D.TAxis.Create(VERTICAL, Graph);
 ax.Color := $00FF0000;
 ax.Position := 1E10;
 ax.Min := 0;
 ax.Max := 400;

 voltageStability := TGraph2D.TLine.Create(Graph);
 voltageStability.YAxis := Graph.YAxis[1];
 voltageStability.isFunction := true;
 voltageStability.Style := DASHED;
 switchOnVoltage := TGraph2D.TLine.Create(Graph);
 switchOnVoltage.YAxis := Graph.YAxis[1];
 switchOnVoltage.isFunction := true;
 switchOnCurrent := TGraph2D.TLine.Create(Graph);
 switchOnCurrent.isFunction := true;
 switchOffCurrent := TGraph2D.TLine.Create(Graph);
 switchOffCurrent.isFunction := true;
 switchOffCurrent.Style := DASHED;


 TSRCValues.Init;

 // Gui
 EditErr.BringToFront;
 startH := Circuit.Height;
 startW := Circuit.Width;
 addRel(Label1, 0);
 addRel(Label16, 0);
 addRel(EditCres, 0);
 addRel(EditCq1, 1);
 addRel(EditCq2, 1);
 addRel(EditLs1, 1);
 addRel(EditLs2, 1);
 addRel(EditLh, 0);
 addRel(EditR2, 1);
 addRel(LabelVout, 1);
 addRel(Label22, 0);
 addRel(LabelAlert, 1);
 Circuit.AnchorParallel(akRight, 0, TabSheet1);
 Circuit.AnchorParallel(akBottom, 0, TabSheet1);
 CircuitU.AnchorParallel(akRight, 0, TabSheet1);
 CircuitU.AnchorParallel(akBottom, 0, TabSheet1);
 TabSheet1.Show;

 // Load
 SetCurrentDir(ExtractFilePath(ParamStr(0)));
 if (FileExists(ParamStr(1))) then begin
  settingsFile := ParamStr(1);
  OpenFile(nil);
 end;
 SetValues(sender);
end;

procedure TForm1.FrameResize(Sender: TObject);
var i : integer;
begin
 for i := 0 to Length(relativePositions)-1 do begin
  if (relativePositions[i].a and 1 = 1) then relativePositions[i].el.Top := Trunc((relativePositions[i].t + relativePositions[i].el.Height) / startH * TabSheet1.Height) - relativePositions[i].el.Height
  else relativePositions[i].el.Top := Trunc(relativePositions[i].t / startH * TabSheet1.Height);
  relativePositions[i].el.Left := Trunc(relativePositions[i].l / startW * TabSheet1.Width);
 end;
end;

procedure TForm1.LogEnableDisable(Sender: TObject);
begin
 TSRCValues.logEnabled := CheckBox4.Checked;;
end;

procedure TForm1.CheckBoxChange(Sender: TObject);
begin
 if (CheckBox1.Checked) then begin EditLs2.Color := clSilver; EditLs2.Readonly := true; end
 else begin EditLs2.Color := clWhite; EditLs2.Readonly := false; end;
 if (CheckBox2.Checked) then begin EditCres.Color := clSilver; EditCres.Readonly := true; Label16.Visible := true; Label21.Visible := true; Trackbar1.Visible := true; end
 else begin EditCres.Color := clWhite; EditCres.Readonly := false; Label16.Visible := false; Label21.Visible := false; Trackbar1.Visible := false; end;
 if (CheckBox3.Checked) then begin EditCq2.Color := clSilver; EditCq2.Readonly := true; end
 else begin EditCq2.Color := clWhite; EditCq2.Readonly := false; end;
 if (RadioButton1.Checked) then begin EditIOut.Readonly := false; EditIOut.Color := clWhite; EditVout.ReadOnly := true; EditVOut.Color := clSilver; EditIOutU.Readonly := false; EditIOutU.Color := clWhite; EditVoutU.ReadOnly := true; EditVOutU.Color := clSilver; end
 else begin EditIOut.Readonly := true; EditIOut.Color := clSilver; EditVout.ReadOnly := false; EditVOut.Color := clWhite; EditIOutU.Readonly := true; EditIOutU.Color := clSilver; EditVoutU.ReadOnly := false; EditVOutU.Color := clWhite; end;
 SetValues(Sender);
end;

procedure TForm1.ParamChange(Sender: TObject);
begin
 Timer1.Enabled := false;
 Timer1.Enabled := true;
end;

procedure TForm1.OpenFile(Sender: TObject);
var ini : TINIFile;
begin
 if (Sender <> nil) then begin
  if (not OpenDialog1.Execute) then exit;
  settingsFile := OpenDialog1.FileName;
 end;
 ini := TINIFile.Create(settingsFile);
 // Elements
 EditVin.Text  := ini.ReadString('Elements', 'Vin', '380');
 EditCq1.Text  := ini.ReadString('Elements', 'Cq1', '40p');
 EditCq2.Text  := ini.ReadString('Elements', 'Cq2', '40p');
 EditCres.Text := ini.ReadString('Elements', 'Cres', '100n');
 EditLs1.Text  := ini.ReadString('Elements', 'Ls1', '5u');
 EditU.Text    := ini.ReadString('Elements', 'u', '10');
 EditLh.Text   := ini.ReadString('Elements', 'Lh', '700u');
 EditLs2.Text  := ini.ReadString('Elements', 'Ls2', '5u');
 EditR2.Text   := ini.ReadString('Elements', 'R2', '100m');
 EditIout.Text := ini.ReadString('Elements', 'Iout', '1A');
 EditVout.Text := ini.ReadString('Elements', 'Vout', '180V');
 EditCres.Text := ini.ReadString('Elements', 'Cres', '100n');
 CheckBox3.Checked := ini.ReadBool('Elements', 'Cq1Cq2', true);
 CheckBox2.Checked := ini.ReadBool('Elements', 'CresAuto', false);
 CheckBox1.Checked := ini.ReadBool('Elements', 'Ls1Ls2', true);
 CheckBoxTransform.Checked := ini.ReadBool('Elements', 'ShowTransformed', true);
 RadioButton1.Checked := ini.ReadBool('Elements', 'CalcI', true); RadioButton2.Checked := not RadioButton1.Checked;
 Trackbar1.Position := ini.ReadInteger('Elements', 'Resonance', 50);
 // Clocking
 EditTon.Text  := ini.ReadString('Clocking', 'Ton', '3u');
 EditToff.Text := ini.ReadString('Clocking', 'Toff', '50n');
 // Show
 EditSteps.Text := ini.ReadString('Show', 'Steps', '20');
 // Export
 EditExportPath.Text := ini.ReadString('Export', 'Path', '');
 EditExportName.Text := ini.ReadString('Export', 'Name', 'analysis');
 SpinEditExportResolution.Value := ini.ReadInteger('Export', 'Resolution', 4000);
 CheckBoxAutoDel.Checked := ini.ReadBool('Export', 'AutoDel', false);
 ini.Free;
end;

procedure TForm1.SaveFile(Sender: TObject);
var ini : TINIFile;
begin
 if (settingsFile = '') then begin SaveFileAs(Sender); exit; end;
 ini := TINIFile.Create(settingsFile);
 ini.WriteString('Elements', 'Vin', EditVin.Text);
 ini.WriteString('Elements', 'Cq1', EditCq1.Text);
 ini.WriteString('Elements', 'Cq2', EditCq2.Text);
 ini.WriteString('Elements', 'Cres', EditCres.Text);
 ini.WriteString('Elements', 'Ls1', EditLs1.Text);
 ini.WriteString('Elements', 'u', EditU.Text);
 ini.WriteString('Elements', 'Lh', EditLh.Text);
 ini.WriteString('Elements', 'Ls2', EditLs2.Text);
 ini.WriteString('Elements', 'R2', EditR2.Text);
 ini.WriteString('Elements', 'Iout', EditIout.Text);
 ini.WriteString('Elements', 'Vout', EditVout.Text);
 ini.WriteString('Elements', 'Cres', EditCres.Text);
 ini.WriteBool('Elements', 'Cq1Cq2', CheckBox3.Checked);
 ini.WriteBool('Elements', 'CresAuto', CheckBox2.Checked);
 ini.WriteBool('Elements', 'Ls1Ls2', CheckBox1.Checked);
 ini.WriteBool('Elements', 'ShowTransformed', CheckBoxTransform.Checked);
 ini.WriteBool('Elements', 'CalcI', RadioButton1.Checked);
 ini.WriteInteger('Elements', 'Resonance', Trackbar1.Position);
 // Clocking
 ini.WriteString('Clocking', 'Ton', EditTon.Text);
 ini.WriteString('Clocking', 'Toff', EditToff.Text);
 // Show
 ini.WriteString('Show', 'Steps', EditSteps.Text);
 // Export
 ini.WriteString('Export', 'Path', EditExportPath.Text);
 ini.WriteString('Export', 'Name', EditExportName.Text);
 ini.WriteInteger('Export', 'Resolution', SpinEditExportResolution.Value);
 ini.WriteBool('Export', 'AutoDel', CheckBoxAutoDel.Checked);
 ini.Free;
end;

procedure TForm1.SaveFileAs(Sender: TObject);
begin
 if (not SaveDialog1.Execute) then exit;
 if (FileExists(SaveDialog1.FileName)) and (MessageDlg('File exists. Overwrite?', MtCustom, [MbYes, MbAbort], 0) = mrAbort) then exit;
 settingsFile := SaveDialog1.FileName;
 SaveFile(Sender);
end;

procedure TForm1.SetValues(Sender: TObject);
var
 i : integer;
 T : Precision;
begin
 Timer1.Enabled := false;
 err := false;
 // Primary side (except of Cres)
 TSRCValues.Vin := ValToFloat('', EditVin);
 TSRCValues.Cq1 := ValToFloat('', EditCq1);
 if (CheckBox3.Checked) then begin TSRCValues.Cq2 := TSRCValues.Cq1; EditCq2.Text := EditCq1.Text; end
 else TSRCValues.Cq2 := ValToFloat('', EditCq2);
 TSRCValues.Ls1 := ValToFloat('', EditLs1);
 TSRCValues.Lh := ValToFloat('', EditLh);
 TSRCValues.U_ := ValToFloat('', EditU);
 if (Poly.IsNaN(TSRCValues.U_)) then TSRCValues.U_ := 1;
 // Secondary Side
 if (CheckBox1.Checked) then begin TSRCValues.Ls2 := TSRCValues.Ls1; EditLs2.Text := EditLs1.Text; EditLs2U.Text := TGraph2D.FloatToPhysStr(TSRCValues.Ls2, 4); end;
 if (CheckBoxTransform.Checked) then begin
  if (not CheckBox1.Checked) then TSRCValues.Ls2 := ValToFloat('', EditLs2);
  TSRCValues.R2 := ValToFloat('', EditR2);
  TSRCValues.Vout := ValToFloat('', EditVout);
  Iout := ValToFloat('', EditIOut);
  EditLs2U.Text := TGraph2D.FloatToPhysStr(TSRCValues.Ls2/(TSRCValues.U_**2), 4);
  EditR2U.Text := TGraph2D.FloatToPhysStr(TSRCValues.R2/(TSRCValues.U_**2), 4);
  EditVoutU.Text := TGraph2D.FloatToPhysStr(TSRCValues.Vout/TSRCValues.U_, 4);
  EditIoutU.Text := TGraph2D.FloatToPhysStr(Iout*TSRCValues.U_, 4);
 end else begin
  if (not CheckBox1.Checked) then TSRCValues.Ls2 := ValToFloat('', EditLs2U)*TSRCValues.U_**2;
  TSRCValues.R2 := ValToFloat('', EditR2U)*TSRCValues.U_**2;
  TSRCValues.Vout := ValToFloat('', EditVoutU)*TSRCValues.U_;
  Iout := ValToFloat('', EditIOutU)/TSRCValues.U_;
  EditLs2.Text := TGraph2D.FloatToPhysStr(TSRCValues.Ls2, 4);
  EditR2.Text := TGraph2D.FloatToPhysStr(TSRCValues.R2, 4);
  EditVout.Text := TGraph2D.FloatToPhysStr(TSRCValues.Vout, 4);
  EditIout.Text := TGraph2D.FloatToPhysStr(Iout, 4);
 end;
 // Cres & Frequency
 TSRCValues.Ton := ValToFloat('', EditTon);
 TSRCValues.Toff := ValToFloat('', EditToff);
 if (CheckBox2.Checked) then begin
  if (Poly.IsNaN(TSRCValues.Ton)) or (Poly.IsNaN(TSRCValues.Ton)) or (Poly.IsNaN(TSRCValues.Ls1)) or (Poly.IsNaN(TSRCValues.Ls2)) then begin
   TSRCValues.Cres := Poly.NaN;
   EditCres.Text := '';
   LabelF.Caption := '';
  end else begin
   TSRCValues.Cres := (2*(TSRCValues.Ton+TSRCValues.Toff))**2 * (Trackbar1.Position * 1.5 / 100 + 0.5)**2 / (4*PI**2*(TSRCValues.Ls1 + TSRCValues.Ls2));
   EditCres.Text := TGraph2D.FloatToPhysStr(TSRCValues.Cres, 4);
  end;
 end else TSRCValues.Cres := ValToFloat('', EditCres);
 LabelF.Caption := TGraph2D.FloatToPhysStr(1/(2*(TSRCValues.Ton+TSRCValues.Toff)));
 steps := ValToInt(EditSteps);
 // Init
 Timer1.Enabled := false;
 TSRCValues.isInitVal := false;
 TSRCValues.Ih_0_def := 0;
 TSRCValues.Vcres_0_def := 190;
 ShowChange(sender);
 LabelAlert.Visible := TSRCValues.isInitVal and not err;
end;

procedure TForm1.ShowChange(Sender: TObject);
var
 i : integer;
 x, Max, v : Precision;
begin
 Max := 1;
 voltageStability.visible := false;
 switchOnVoltage.visible := false;
 switchOnCurrent.visible := false;
 switchOffCurrent.visible := false;
 Image2.Visible := true;
 Image3.Visible := false;
 if (RadioButton3.Checked) then begin // Transient
  TSRCValues.I2_0_def := 0;
  TSRCValues.Ih_0_def := 0;
  TSRCValues.Vcres_0_def := TSRCValues.Vin/2;
  TSRCValues.update;
  Max := 2*(TSRCValues.Ton+TSRCValues.Toff);
 end else if (RadioButton4.Checked) then begin // Steady state
  if (RadioButton1.Checked) then begin
   v := TSRCValues.gotoSteadyState(Iout * 2*(TSRCValues.Ton + TSRCValues.Toff), -1);
   EditVout.Text := TGraph2D.FloatToPhysStr(v, 4);
   EditVoutU.Text := TGraph2D.FloatToPhysStr(v/TSRCValues.U_, 4);
  end else TSRCValues.gotoSteadyState(-1, TSRCValues.Vout);
  Max := 2*(TSRCValues.Ton+TSRCValues.Toff);
 end else begin // Switching Losses
  TSRCValues.Clear;
  if (steps <= 0) then exit;
  SetLength(voltageStability.Buff, steps);
  SetLength(switchOnVoltage.Buff, steps);
  SetLength(switchOnCurrent.Buff, steps);
  SetLength(switchOffCurrent.Buff, steps);
  for i := 0 to Steps-1 do begin
   x := i / (Steps-1) * Iout;
   voltageStability.Buff[i].x := x;
   voltageStability.Buff[i].y := TSRCValues.gotoSteadyState(x * 2*(TSRCValues.Ton + TSRCValues.Toff), -1);
   switchOnVoltage.Buff[i].x := x;
   switchOnVoltage.Buff[i].y := TSRCValues.switchOnVoltage;
   switchOnCurrent.Buff[i].x := x;
   switchOnCurrent.Buff[i].y := TSRCValues.switchOnCurrent;
   switchOffCurrent.Buff[i].x := x;
   switchOffCurrent.Buff[i].y := TSRCValues.switchOffCurrent;
  end;
  voltageStability.visible := true;
  switchOnVoltage.visible := true;
  switchOnCurrent.visible := true;
  switchOffCurrent.visible := true;
  Max := Iout;
  Image2.Visible := false;
  Image3.Visible := true;
 end;
 Timer1.Enabled := false;
 // paint
 if (CheckBoxAutoView.Checked) and (not Poly.IsNaN(TSRCValues.Ton)) and (not Poly.IsNaN(TSRCValues.Toff)) then begin
  TGraph2D(Graph).XAxis[0].Min := 0;
  TGraph2D(Graph).XAxis[0].Max := Max;
  TGraph2D(Graph).doPaint(Sender);
  for i := 0 to Length(TGraph2D(Graph).YAxis)-1 do TGraph2D(Graph).YAxis[i].SetFKTExtrema;
  TGraph2D(Graph).doPaint(Sender);
 end else TGraph2D(Graph).doPaint(Sender);
 // err
 if (TSRCValues.lastError = '') then EditErr.Visible := false
 else begin
  EditErr.Text := TSRCValues.lastError;
  EditErr.Visible := true;
 end;
end;

procedure TForm1.ShowLog(Sender: TObject);
var i, j : integer;
begin
 MemoLog.Lines.Clear;
 j := Length(TSRCValues.logArr)-100;
 if (j < 0) then j := 0 else MemoLog.Lines.Add('[...]');
 for i := j to Length(TSRCValues.logArr)-1 do MemoLog.Lines.Add(TSRCValues.logArr[i]);
end;

procedure TForm1.TransformChange(Sender: TObject);
begin
 EditLs2U.Visible := not CheckBoxTransform.Checked;
 EditR2U.Visible := not CheckBoxTransform.Checked;
 EditIoutU.Visible := not CheckBoxTransform.Checked;
 EditVoutU.Visible := not CheckBoxTransform.Checked;
 Circuit.Visible := CheckBoxTransform.Checked;
 CircuitU.Visible := not CheckBoxTransform.Checked;
 if (CheckBoxTransform.Checked) then begin
  LabelIout.Caption := 'I'+#39+'out = ';
  LabelVout.Caption := 'V'+#39+'out = ';
 end else begin
  LabelIout.Caption := 'Iout = ';
  LabelVout.Caption := 'Vout = ';
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 TSRCValues.Clear;
end;

procedure TForm1.DoExport(Sender: TObject);
var
 str : TMemoryStream;
 s : String;
 SR : TSearchRec;
begin
 ButtonExport.Enabled := false;
 ButtonExport.Caption := 'Exporting...';
 TimerExport.Enabled := true;
 s := EditExportPath.Text;
 if (s <> '') and (s[Length(s)] <> '\') and (s[Length(s)] <> '/') then s := s + '\';
 if (CheckBoxAutoDel.Checked) then begin
  if (settingsFile = '') then SetCurrentDir(ExtractFilePath(ParamStr(0)))
  else SetCurrentDir(ExtractFilePath(settingsFile));
  if (FindFirst(s + '*', faAnyFile - faDirectory, SR) = 0) then try
   repeat begin
    if (LeftStr(SR.Name, Length(EditExportName.Text)+1) = EditExportName.Text+'_') then deleteFile(s+SR.Name);
   end; until FindNext(SR) <> 0;
  finally
   FindClose(SR);
  end;
 end;
 str := TMemoryStream.Create;
 Graph.SaveDataToStream(str, SpinEditExportResolution.Value);
 if (settingsFile = '') then SetCurrentDir(ExtractFilePath(ParamStr(0)))
 else SetCurrentDir(ExtractFilePath(settingsFile));
 s := s + EditExportName.Text + '_'+FloatToStr(ValToFloat(EditVin.Text, nil))+'#V' + '_'+FloatToStr(ValToFloat(EditIoutU.Text, nil))+'#A' + '_'+FloatToStr(ValToFloat(EditVoutU.Text, nil))+'#V' + '_'+IntToStr(Round(ValToFloat(LabelF.Caption, nil)/1000))+'kHz' + '.table';
 str.SaveToFile(s);
 str.Free;
end;

procedure TForm1.ExportFinish(Sender: TObject);
begin
 ButtonExport.Enabled := true;
 ButtonExport.Caption := 'Export';
 TimerExport.Enabled := false;
end;


end.

